<?php
# ---------------------------------------------------------------------------------

/**
* @version v 1.5
* @author: Gero Zahn, gero@gerozahn.de, http://www.gerozahn.de/bot_gzFlashEmbed/
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.*/

# ---------------------------------------------------------------------------------

/** ensure this file is being included by a parent file */
defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_MAMBOTS->registerFunction( 'onSearch', 'botSearchgzFlashEmbed' );

# ---------------------------------------------------------------------------------

/**
* gzFlashEmbed Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param string mathcing option, exact|any|all
* @param string ordering option, newest|oldest|popular|alpha|category
*/
function botSearchgzFlashEmbed( $text, $phrase='', $ordering='' ) {
	global $database, $my, $_MAMBOTS;

	# Strategy: We'll first search in our Flash text cache to find out in which
	# indexed Flash text the search term is in.
	# Afterwards we'll ask the regular content filter for those contents in which
	# the found Flash clips are embedded.
	# ... For that we use the plain old content search -- or, if possible,
	# the JoomFish multiling content search.

	# So: First check if one either jfcontent.searchbot or content.searchbot
	# is installed. If not - well, then the entire search makes no sense.

	$subsearches=array(); # Sanity - no sub-search
	$result=array(); # Sanity - no result

	foreach($_MAMBOTS->_events["onSearch"] as $searchbot) {
		if ($searchbot[0]=="botSearchJFContent") { # JoomFish content search available?
			$subsearches[]=$searchbot[0]; # Take a note ...
		}
		if ($searchbot[0]=="botSearchContent") { # Regular content search available?
			$subsearches[]=$searchbot[0]; # Take a note ...
		}
	}

	if ($subsearches) { # Found at least one subsearch - regular content search and/or JoomFish content seach?

		# Yes - let's get going and search for the Flash words.

		switch ($phrase) { # The usual - exact, all, any
			case 'exact':
				$where 		= "(LOWER(a.swftext) LIKE '%$text%')";
				break;
				
			case 'all':
			case 'any':
			default:
				$words = explode( " ", $text );
				$wheres = array();
				foreach ($words as $word) {
					$wheres[] 	= "(LOWER(a.swftext) LIKE '%$word%')";
				}
				$where = "(" . implode( ($phrase == "all" ? ") AND (" : ") OR ("), $wheres ) . ")";
				break;
		}

		$sql="SELECT swffilename FROM #__gzflashembed AS a WHERE $where"; # Get the Flash file names

		$database->setQuery($sql);
		$rows = $database->loadObjectList();

		$words=array(); # Each SWF file will be a "word" now to be searched in the content elements
		foreach($rows as $row) {
			$words[]=$row->swffilename;
		}
		$words=implode(" ",$words);

#		echo "$words <pre>"; print_r($subsearches); echo "</pre>\n";

		$result=array(); # Yet empty, but let's see ...

		foreach($subsearches as $subsearch) { # ... let's get through all subsearches
			$result=array_merge($result,$subsearch($words,"any",$ordering)); # And here we go!
#			echo "<br \>\n$subsearch ".count($result)."<br \>\n";
		}

	} # if ($subsearches)

	return $result;

}

# ---------------------------------------------------------------------------------

?>